# Ajuste lineal de elipses
# minimizando el cuadrado de las "distancias"
# algebraicas
import numpy as np
import scipy.linalg as scipy
import sys

n = len( sys.argv )
if n != 2 :
	print( "Args: archivo_entrada" )
	sys.exit( 1 )

nombre = sys.argv[1]

X = np.loadtxt( nombre )
print( X.shape )

# Hacemos la matriz
S1 = np.zeros( (3,3) )
S2 = np.zeros( (3,3) )
S3 = np.zeros( (3,3) )
B = np.zeros( (3,3) )
C1 = np.zeros( (3,3) )
C1[0,2] = -2
C1[1,1] = 1
C1[2,0] = -2

C1inv = np.array( [[-0. , -0. ,  -0.5],
                   [ 0. ,  1. ,   0. ],
                   [-0.5, -0. ,  -0. ]] )

n, m = X.shape
i=0
#             [    4       3        2  2      3      2       2   ]
#             [  [x ]    [x  y]   [x  y ]   [x ]   [x  y]  [x ]  ]
#             [                                                  ]
#             [   3        2  2       3      2         2         ]
#             [ [x  y]   [x  y ]  [x y ]   [x  y]  [x y ]  [x y] ]
#             [                                                  ]
#             [   2  2       3       4         2      3      2   ]
#             [ [x  y ]  [x y ]    [y ]    [x y ]   [y ]   [y ]  ]
#(%o3)        [                                                  ]
#             [    3       2          2       2                  ]
#             [  [x ]    [x  y]   [x y ]    [x ]   [x y]    [x]  ]
#             [                                                  ]
#             [   2          2       3                2          ]
#             [ [x  y]   [x y ]    [y ]    [x y]    [y ]    [y]  ]
#             [                                                  ]
#             [    2                 2                           ]
#             [  [x ]     [x y]    [y ]     [x]     [y]     [1]  ]

while i < n :
	# Calculamos S1
	x = X[i,0]
	y = X[i,1]
	B[0,0] = x*x*x*x	
	B[0,1] = x*x*x*y	
	B[0,2] = x*x*y*y	
	B[1,0] = B[0,1]
	B[1,1] = B[0,2]
	B[1,2] = x*y*y*y
	B[2,0] = B[0,2]
	B[2,1] = B[1,2]
	B[2,2] = y*y*y*y
	S1 += B

	# Calculamos S2
	B[0,0] = x*x*x	
	B[0,1] = x*x*y	
	B[0,2] = x*x	
	B[1,0] = B[0,1]
	B[1,1] = x*y*y
	B[1,2] = x*y
	B[2,0] = B[1,1]
	B[2,1] = y*y*y
	B[2,2] = y*y
	S2 += B

	# Calculamos S3
	B[0,0] = x*x	
	B[0,1] = x*y	
	B[0,2] = x	
	B[1,0] = B[0,1]
	B[1,1] = y*y
	B[1,2] = y
	B[2,0] = B[0,2]
	B[2,1] = B[1,2]
	B[2,2] = 1
	S3 += B

	i +=1

G = S1 - S2 @ np.linalg.inv(S3) @ S2.T

e, E = scipy.eig( G, C1 )
print( "La eigendescomposición" )
print( e )
print( E )

G1 = C1inv @ G
print( "G1" )
print( G1 )

e1, E1 = np.linalg.eig( G1 )
print( "La eigendescomposición" )
print( e1 )
print( E1 )

# Checamos cuál es la solución que cumple la restricción
i=0
while i<3 :
	a = E[0,i]
	b = E[1,i]
	c = E[2,i]

	v = b*b - 4*a*c
	print( i, v )
	if v < 0 :
		break

	i += 1

va1 = np.zeros( (3,1) )
va1[0,0] = a
va1[1,0] = b
va1[2,0] = c
va2 = np.zeros( (3,1) )
va2 = - np.linalg.inv(S3) @ S2.T @ va1 

print( va1[0,0], va1[1,0], va1[2,0], va2[0,0], va2[1,0], va2[2,0] )

